fc9c886a3b0909697245e17891763acd6034cc96
[csit.git] / resources / libraries / bash / function / artifacts.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2019 Cisco and/or its affiliates.
4 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at:
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 set -exuo pipefail
18
19 function download_artifacts () {
20     # Get and/or install VPP artifacts from packagecloud.io.
21     #
22     # Variables read:
23     # - CSIT_DIR - Path to existing root of local CSIT git repository.
24     # Variables set:
25     # - REPO_URL - FD.io Packagecloud repository.
26
27     set -exuo pipefail
28
29     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
30         die "Get OS release failed."
31     }
32
33     repo_url_path="${CSIT_DIR}/VPP_REPO_URL"
34     if [ -e "${repo_url_path}" ]; then
35         REPO_URL="$(<${repo_url_path})" || {
36             die "Read repo URL from ${repo_url_path} failed."
37         }
38     else
39         REPO_URL="https://packagecloud.io/install/repositories/fdio/master"
40     fi
41
42     if [ "${os_id}" == "ubuntu" ]; then
43         download_ubuntu_artifacts || die
44     elif [ "${os_id}" == "centos" ]; then
45         download_centos_artifacts || die
46     elif [ "${os_id}" == "opensuse" ]; then
47         download_opensuse_artifacts || die
48     else
49         die "${os_id} is not yet supported."
50     fi
51 }
52
53 function download_ubuntu_artifacts () {
54     # Get and/or install Ubuntu VPP artifacts from packagecloud.io.
55     #
56     # Variables read:
57     # - REPO_URL - FD.io Packagecloud repository.
58     # - VPP_VERSION - VPP version.
59     # - INSTALL - If install packages or download only. Default: download
60
61     set -exuo pipefail
62
63     curl -s "${REPO_URL}"/script.deb.sh | sudo bash || {
64         die "Packagecloud FD.io repo fetch failed."
65     }
66     # If version is set we will add suffix.
67     artifacts=()
68     both_quotes='"'"'"
69     match="[^${both_quotes}]*"
70     qmatch="[${both_quotes}]\?"
71     sed_command="s#.*apt_source_path=${qmatch}\(${match}\)${qmatch}#\1#p"
72     apt_fdio_repo_file=$(curl -s "${REPO_URL}"/script.deb.sh | \
73                          sed -n ${sed_command}) || {
74                              die "Local fdio repo file path fetch failed."
75                          }
76
77     if [ ! -f ${apt_fdio_repo_file} ]; then
78         die "${apt_fdio_repo_file} not found, \
79             repository installation was not successful."
80     fi
81
82     packages=$(apt-cache -o Dir::Etc::SourceList=${apt_fdio_repo_file} \
83                -o Dir::Etc::SourceParts=${apt_fdio_repo_file} dumpavail \
84                | grep Package: | cut -d " " -f 2) || {
85                    die "Retrieval of available VPP packages failed."
86                }
87     if [ -z "${VPP_VERSION-}" ]; then
88         # If version is not specified, find out the most recent version
89         VPP_VERSION=$(apt-cache -o Dir::Etc::SourceList=${apt_fdio_repo_file} \
90                       -o Dir::Etc::SourceParts=${apt_fdio_repo_file} \
91                       --no-all-versions show vpp | grep Version: | \
92                       cut -d " " -f 2) || {
93                           die "Retrieval of most recent VPP version failed."
94                       }
95     fi
96
97     set +x
98     for package in ${packages}; do
99         # Filter packages with given version
100         pkg_info=$(apt-cache show ${package}) || {
101             die "apt-cache show on ${package} failed."
102         }
103         ver=$(echo ${pkg_info} | grep -o "Version: ${VPP_VERSION-}[^ ]*" | \
104               head -1) || true
105         if [ -n "${ver-}" ]; then
106             echo "Found '${VPP_VERSION-}' among '${package}' versions."
107             ver=$(echo "$ver" | cut -d " " -f 2)
108             artifacts+=(${package[@]/%/=${ver-}})
109         else
110             echo "Didn't find '${VPP_VERSION-}' among '${package}' versions."
111         fi
112     done
113     set -x
114
115     if [ "${INSTALL:-false}" = true ]; then
116         sudo apt-get -y install "${artifacts[@]}" || {
117             die "Install VPP artifacts failed."
118         }
119     else
120         apt-get -y download "${artifacts[@]}" || {
121             die "Download VPP artifacts failed."
122         }
123     fi
124 }
125
126 function download_centos_artifacts () {
127     # Get and/or install CentOS VPP artifacts from packagecloud.io.
128     #
129     # Variables read:
130     # - REPO_URL - FD.io Packagecloud repository.
131     # - VPP_VERSION - VPP version.
132     # - INSTALL - If install packages or download only. Default: download
133
134     set -exuo pipefail
135
136     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
137         die "Packagecloud FD.io repo fetch failed."
138     }
139     # If version is set we will add suffix.
140     artifacts=()
141     packages=(vpp vpp-selinux-policy vpp-devel vpp-lib vpp-plugins vpp-api-python)
142     if [ -z "${VPP_VERSION-}" ]; then
143         artifacts+=(${packages[@]})
144     else
145         artifacts+=(${packages[@]/%/-${VPP_VERSION-}})
146     fi
147
148     if [ "${INSTALL:-false}" = true ]; then
149         sudo yum -y install "${artifacts[@]}" || {
150             die "Install VPP artifact failed."
151         }
152     else
153         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
154             die "Download VPP artifacts failed."
155         }
156     fi
157 }
158
159 function download_opensuse_artifacts () {
160     # Get and/or install OpenSuSE VPP artifacts from packagecloud.io.
161     #
162     # Variables read:
163     # - REPO_URL - FD.io Packagecloud repository.
164     # - VPP_VERSION - VPP version.
165     # - INSTALL - If install packages or download only. Default: download
166
167     set -exuo pipefail
168
169     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
170         die "Packagecloud FD.io repo fetch failed."
171     }
172     # If version is set we will add suffix.
173     artifacts=()
174     packages=(vpp vpp-devel vpp-lib vpp-plugins libvpp0)
175     if [ -z "${VPP_VERSION-}" ]; then
176         artifacts+=(${packages[@]})
177     else
178         artifacts+=(${packages[@]/%/-${VPP_VERSION-}})
179     fi
180
181     if [ "${INSTALL:-false}" = true ]; then
182         sudo yum -y install "${artifacts[@]}" || {
183             die "Install VPP artifact failed."
184         }
185     else
186         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
187             die "Download VPP artifacts failed."
188         }
189     fi
190 }